github-google-ctf/2019/finals/web-gphotos-finals/app/gallery/urls.py
# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     https://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

from django.urls import path

from . import views

app_name = 'gallery'
urlpatterns = [
    path('', views.index, name='index'),
    path('new/', views.new, name='new'),
]

github-google-ctf/2019/finals/web-gphotos-finals/app/project/urls.py
# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     https://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

from django.urls import include, path
from django.conf import settings
from django.views.static import serve
from django.urls import re_path

urlpatterns = [
    path('', include('gallery.urls')),
]

urlpatterns += [
    re_path(r'^static/(?P<path>.*)$', serve, {
        'document_root': settings.STATIC_ROOT,
    }),
]

urlpatterns += [
    re_path(r'^media/(?P<path>.*)$', serve, {
        'document_root': settings.MEDIA_ROOT,
    }),
]

github-google-ctf/2019/finals/web-gphotos-finals/app/gallery/forms.py
# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     https://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

from django import forms

import imghdr


class ImageForm(forms.Form):
  image = forms.FileField()

  def clean_image(self):
    content = self.cleaned_data['image']

    if content.size > 200000:
      raise forms.ValidationError('File too large')

    if imghdr.what(content) not in ['png', 'jpg', 'jpeg']:
      raise forms.ValidationError('Bad file type')

    return content

github-google-ctf/2019/finals/web-gphotos-finals/app/gallery/views.py
# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     https://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

from django.http import HttpResponse, HttpResponseRedirect # noqa: 401
from django.shortcuts import render
from django.core.files.storage import FileSystemStorage

from wand.image import Image

import os
import imghdr

from .forms import ImageForm


def index(request):
  try:
    images = os.listdir(os.path.join('media/{user_id}/thumbs/'\
      .format(user_id=request.user_id)))
  except:
    images = []

  return render(request, 'gallery/index.html',\
    {'user_id': request.user_id, 'images': images})


def new(request):
  form = ImageForm()

  if request.method == 'POST':
    form = ImageForm(request.POST, request.FILES)

    if form.is_valid():
      file = request.FILES['image']
      parts = os.path.splitext(file.name)
      location = os.path.join('media', request.user_id)

      fs = FileSystemStorage(location=location)
      filename = fs.save('{base}{extension}'.format(base=parts[0],\
        extension=parts[1]), file)
      original_path = os.path.join('media', request.user_id, filename)

      with Image(filename=original_path) as img:
        with img.clone() as image:
          image.transform(resize='x150')
          image.format = imghdr.what(original_path)
          thumb_path = os.path.join('media', request.user_id, 'thumbs',\
            filename)
          image.save(filename=thumb_path)

      return HttpResponseRedirect('/')

  return render(request, 'gallery/new.html', {'form': form})

github-google-ctf/2019/finals/web-gphotos-finals/app/gallery/templates/gallery/base.html
{% comment %}
Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    https://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
{% endcomment %}
{% load static %}
{% spaceless %}
<!DOCTYPE html>
<html>
  <head>
    <title>gPhotos2</title>
    <link href="https://fonts.googleapis.com/icon?family=Material+Icons" rel="stylesheet">

    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/materialize/1.0.0/css/materialize.min.css">
    <link rel="stylesheet" href="https://cdn.jsdelivr.net/gh/fancyapps/fancybox@3.5.7/dist/jquery.fancybox.min.css" />

    <meta name="viewport" content="width=device-width, initial-scale=1.0"/>
  </head>

  <body class="grey darken-3">

    <nav class="nav-extended black darken-4">
      <div class="nav-wrapper container">

          <a href="/" class="brand-logo">
            <i class="material-icons"><img src="{% static "logo.png" %}"/></i>gPhotos2
            <span class="hide-on-med-and-down" style="font-size: 11px; color: #aaa">>Discover the most secure photo gallery ever released!</span>
          </a>

          <a href="#" data-target="mobile" class="sidenav-trigger"><i class="material-icons">menu</i></a>

        <ul id="nav-mobile" class="right hide-on-med-and-down">
          <li><a href="/new"><i class="material-icons left">add_a_photo</i>Upload image</a></li>
        </ul>
      </div>

    </nav>

    <ul class="sidenav" id="mobile">
      <li><a href="/new"><i class="material-icons left">add_a_photo</i>Upload image</a></li>
    </ul>


    <div class="container" style="margin-top: 20px">
      {% block content %}{% endblock %}
    </div>

    <script src="https://cdnjs.cloudflare.com/ajax/libs/materialize/1.0.0/js/materialize.min.js"></script>

    <script src="//code.jquery.com/jquery-3.3.1.min.js"></script>
    <script src="https://cdn.jsdelivr.net/gh/fancyapps/fancybox@3.5.7/dist/jquery.fancybox.min.js"></script>

    <script>
      document.addEventListener('DOMContentLoaded', function() {
        M.Sidenav.init(document.querySelectorAll('.sidenav'));
        M.updateTextFields();
      });

    </script>
  </body>
</html>
{% endspaceless %}

github-google-ctf/2019/finals/web-gphotos-finals/app/gallery/templates/gallery/index.html
{% extends "gallery/base.html" %}

{% comment %}
Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    https://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
{% endcomment %}

{% block content %}
    {% for image in images %}
      <a data-fancybox="gallery" href="/media/{{ user_id }}/{{ image }}">
        <img src="/media/{{ user_id }}/thumbs/{{ image }}" style="height:150px; padding-right: 10px;">
      </a>
    {% endfor %}
{% endblock %}

github-google-ctf/2019/finals/web-gphotos-finals/app/gallery/templates/gallery/new.html
{% extends "gallery/base.html" %}

{% comment %}
Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    https://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
{% endcomment %}

{% block content %}

  <div class="row center" style="padding-top:15px">
    <form enctype="multipart/form-data" action="/new/" method="post">
      {% csrf_token %}

      {% if form.errors %}
        <div class="row red-text">
          {% for field in form %}
              {% for error in field.errors %}
                  <div class="alert alert-danger">
                      <strong>{{ error|escape }}</strong>
                  </div>
              {% endfor %}
          {% endfor %}
          {% for error in form.non_field_errors %}
              <div class="alert alert-danger">
                  <strong>{{ error|escape }}</strong>
              </div>
          {% endfor %}
        </div>
      {% endif %}

      <div class="file-field input-field">
        <div class="btn grey darken-2 z-depth-0">
          <span>Select file</span>
          <input type="file" name="image" required id="id_image">
        </div>
        <div class="file-path-wrapper">
          <input class="file-path validate grey-text" type="text" placeholder="No file selected">
        </div>

        <div class="row" style="margin-top:50px">
          <button class=" col s12 btn-large waves-effect waves-light blue" type="submit">Submit</button>
        </div>

    </form>

  </div>

{% endblock %}